<?php

namespace april\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGarantieReference ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGarantieReference
 * @subpackage Arrays
 */
class ArrayOfGarantieReference extends AbstractStructArrayBase
{
    /**
     * The GarantieReference
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \april\StructType\GarantieReference[]
     */
    public $GarantieReference;
    /**
     * Constructor method for ArrayOfGarantieReference
     * @uses ArrayOfGarantieReference::setGarantieReference()
     * @param \april\StructType\GarantieReference[] $garantieReference
     */
    public function __construct(array $garantieReference = array())
    {
        $this
            ->setGarantieReference($garantieReference);
    }
    /**
     * Get GarantieReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \april\StructType\GarantieReference[]|null
     */
    public function getGarantieReference()
    {
        return isset($this->GarantieReference) ? $this->GarantieReference : null;
    }
    /**
     * Set GarantieReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \april\StructType\GarantieReference[] $garantieReference
     * @return \april\ArrayType\ArrayOfGarantieReference
     */
    public function setGarantieReference(array $garantieReference = array())
    {
        foreach ($garantieReference as $arrayOfGarantieReferenceGarantieReferenceItem) {
            // validation for constraint: itemType
            if (!$arrayOfGarantieReferenceGarantieReferenceItem instanceof \april\StructType\GarantieReference) {
                throw new \InvalidArgumentException(sprintf('The GarantieReference property can only contain items of \april\StructType\GarantieReference, "%s" given', is_object($arrayOfGarantieReferenceGarantieReferenceItem) ? get_class($arrayOfGarantieReferenceGarantieReferenceItem) : gettype($arrayOfGarantieReferenceGarantieReferenceItem)), __LINE__);
            }
        }
        if (is_null($garantieReference) || (is_array($garantieReference) && empty($garantieReference))) {
            unset($this->GarantieReference);
        } else {
            $this->GarantieReference = $garantieReference;
        }
        return $this;
    }
    /**
     * Add item to GarantieReference value
     * @throws \InvalidArgumentException
     * @param \april\StructType\GarantieReference $item
     * @return \april\ArrayType\ArrayOfGarantieReference
     */
    public function addToGarantieReference(\april\StructType\GarantieReference $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \april\StructType\GarantieReference) {
            throw new \InvalidArgumentException(sprintf('The GarantieReference property can only contain items of \april\StructType\GarantieReference, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GarantieReference[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \april\StructType\GarantieReference|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \april\StructType\GarantieReference|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \april\StructType\GarantieReference|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \april\StructType\GarantieReference|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \april\StructType\GarantieReference|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GarantieReference
     */
    public function getAttributeName()
    {
        return 'GarantieReference';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \april\ArrayType\ArrayOfGarantieReference
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
