<?php

namespace april;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ObtenirRecommandation' => '\\april\\StructType\\ObtenirRecommandation',
            'DemandeObtenirRecommandation' => '\\april\\StructType\\DemandeObtenirRecommandation',
            'Demande' => '\\april\\StructType\\Demande',
            'Projet' => '\\april\\StructType\\Projet',
            'Assure' => '\\april\\StructType\\Assure',
            'Personne' => '\\april\\StructType\\Personne',
            'Adresse' => '\\april\\StructType\\Adresse',
            'BeneficiaireDeces' => '\\april\\StructType\\BeneficiaireDeces',
            'Contrat' => '\\april\\StructType\\Contrat',
            'ArrayOfCouverture' => '\\april\\ArrayType\\ArrayOfCouverture',
            'Couverture' => '\\april\\StructType\\Couverture',
            'ArrayOfEnfant' => '\\april\\ArrayType\\ArrayOfEnfant',
            'Enfant' => '\\april\\StructType\\Enfant',
            'ArrayOfPromotion' => '\\april\\ArrayType\\ArrayOfPromotion',
            'Promotion' => '\\april\\StructType\\Promotion',
            'Entreprise' => '\\april\\StructType\\Entreprise',
            'ObtenirRecommandationResponse' => '\\april\\StructType\\ObtenirRecommandationResponse',
            'ReponseObtenirRecommandation' => '\\april\\StructType\\ReponseObtenirRecommandation',
            'Reponse' => '\\april\\StructType\\Reponse',
            'ArrayOfMessageMetier' => '\\april\\ArrayType\\ArrayOfMessageMetier',
            'MessageMetier' => '\\april\\StructType\\MessageMetier',
            'ObtenirTarif' => '\\april\\StructType\\ObtenirTarif',
            'DemandeObtenirTarif' => '\\april\\StructType\\DemandeObtenirTarif',
            'ObtenirTarifResponse' => '\\april\\StructType\\ObtenirTarifResponse',
            'ReponseObtenirTarif' => '\\april\\StructType\\ReponseObtenirTarif',
            'Tarif' => '\\april\\StructType\\Tarif',
            'ObtenirDocumentSimulation' => '\\april\\StructType\\ObtenirDocumentSimulation',
            'DemandeObtenirDocumentSimulation' => '\\april\\StructType\\DemandeObtenirDocumentSimulation',
            'ObtenirDocumentSimulationResponse' => '\\april\\StructType\\ObtenirDocumentSimulationResponse',
            'ReponseObtenirDocumentSimulation' => '\\april\\StructType\\ReponseObtenirDocumentSimulation',
            'Document' => '\\april\\StructType\\Document',
            'ObtenirDocumentPreAdhesion' => '\\april\\StructType\\ObtenirDocumentPreAdhesion',
            'DemandeObtenirDocumentPreAdhesion' => '\\april\\StructType\\DemandeObtenirDocumentPreAdhesion',
            'ObtenirDocumentPreAdhesionResponse' => '\\april\\StructType\\ObtenirDocumentPreAdhesionResponse',
            'ReponseObtenirDocumentPreAdhesion' => '\\april\\StructType\\ReponseObtenirDocumentPreAdhesion',
            'EnvoyerSimulationParEmail' => '\\april\\StructType\\EnvoyerSimulationParEmail',
            'DemandeEnvoyerDevisParEmail' => '\\april\\StructType\\DemandeEnvoyerDevisParEmail',
            'EnvoyerSimulationParEmailResponse' => '\\april\\StructType\\EnvoyerSimulationParEmailResponse',
            'ReponseEnvoyerDevisParEmail' => '\\april\\StructType\\ReponseEnvoyerDevisParEmail',
            'DemanderMiseEnRelation' => '\\april\\StructType\\DemanderMiseEnRelation',
            'DemandeDemanderMiseEnRelation' => '\\april\\StructType\\DemandeDemanderMiseEnRelation',
            'DemanderMiseEnRelationResponse' => '\\april\\StructType\\DemanderMiseEnRelationResponse',
            'ReponseDemanderMiseEnRelation' => '\\april\\StructType\\ReponseDemanderMiseEnRelation',
            'ObtenirProfessions' => '\\april\\StructType\\ObtenirProfessions',
            'ObtenirProfessionsResponse' => '\\april\\StructType\\ObtenirProfessionsResponse',
            'ReponseObtenirReferentielProfession' => '\\april\\StructType\\ReponseObtenirReferentielProfession',
            'ArrayOfProfessionReference' => '\\april\\ArrayType\\ArrayOfProfessionReference',
            'ProfessionReference' => '\\april\\StructType\\ProfessionReference',
            'ObtenirRegimesObligatoires' => '\\april\\StructType\\ObtenirRegimesObligatoires',
            'ObtenirRegimesObligatoiresResponse' => '\\april\\StructType\\ObtenirRegimesObligatoiresResponse',
            'ReponseObtenirReferentielRegimeObligatoire' => '\\april\\StructType\\ReponseObtenirReferentielRegimeObligatoire',
            'ArrayOfRegimeObligatoireReference' => '\\april\\ArrayType\\ArrayOfRegimeObligatoireReference',
            'RegimeObligatoireReference' => '\\april\\StructType\\RegimeObligatoireReference',
            'ObtenirGaranties' => '\\april\\StructType\\ObtenirGaranties',
            'ObtenirGarantiesResponse' => '\\april\\StructType\\ObtenirGarantiesResponse',
            'ReponseObtenirReferentielGarantie' => '\\april\\StructType\\ReponseObtenirReferentielGarantie',
            'ArrayOfGarantieReference' => '\\april\\ArrayType\\ArrayOfGarantieReference',
            'GarantieReference' => '\\april\\StructType\\GarantieReference',
            'ArrayOfFranchiseReference' => '\\april\\ArrayType\\ArrayOfFranchiseReference',
            'FranchiseReference' => '\\april\\StructType\\FranchiseReference',
            'ArrayOfNiveauReference' => '\\april\\ArrayType\\ArrayOfNiveauReference',
            'NiveauReference' => '\\april\\StructType\\NiveauReference',
            'ObtenirCommissionnements' => '\\april\\StructType\\ObtenirCommissionnements',
            'ObtenirCommissionnementsResponse' => '\\april\\StructType\\ObtenirCommissionnementsResponse',
            'ReponseObtenirReferentielCommissionnement' => '\\april\\StructType\\ReponseObtenirReferentielCommissionnement',
            'ArrayOfCommissionnementReference' => '\\april\\ArrayType\\ArrayOfCommissionnementReference',
            'CommissionnementReference' => '\\april\\StructType\\CommissionnementReference',
            'ObtenirPays' => '\\april\\StructType\\ObtenirPays',
            'ObtenirPaysResponse' => '\\april\\StructType\\ObtenirPaysResponse',
            'ArrayOfPaysReference' => '\\april\\ArrayType\\ArrayOfPaysReference',
            'PaysReference' => '\\april\\StructType\\PaysReference',
            'ObtenirDepartements' => '\\april\\StructType\\ObtenirDepartements',
            'DemandeObtenirReferentielDepartement' => '\\april\\StructType\\DemandeObtenirReferentielDepartement',
            'ObtenirDepartementsResponse' => '\\april\\StructType\\ObtenirDepartementsResponse',
            'ArrayOfDepartementReference' => '\\april\\ArrayType\\ArrayOfDepartementReference',
            'DepartementReference' => '\\april\\StructType\\DepartementReference',
            'ObtenirVille' => '\\april\\StructType\\ObtenirVille',
            'DemandeObtenirReferentielVille' => '\\april\\StructType\\DemandeObtenirReferentielVille',
            'ObtenirVilleResponse' => '\\april\\StructType\\ObtenirVilleResponse',
            'ArrayOfVilleReference' => '\\april\\ArrayType\\ArrayOfVilleReference',
            'VilleReference' => '\\april\\StructType\\VilleReference',
            'EnregistrerProjet' => '\\april\\StructType\\EnregistrerProjet',
            'DemandeEnregistrerProjet' => '\\april\\StructType\\DemandeEnregistrerProjet',
            'EnregistrerProjetResponse' => '\\april\\StructType\\EnregistrerProjetResponse',
            'ReponseEnregistrerProjet' => '\\april\\StructType\\ReponseEnregistrerProjet',
            'ObtenirURLProjet' => '\\april\\StructType\\ObtenirURLProjet',
            'DemandeObtenirURLProjet' => '\\april\\StructType\\DemandeObtenirURLProjet',
            'ObtenirURLProjetResponse' => '\\april\\StructType\\ObtenirURLProjetResponse',
            'ReponseObtenirURLProjet' => '\\april\\StructType\\ReponseObtenirURLProjet',
            'ObtenirActivitesProfessionnelles' => '\\april\\StructType\\ObtenirActivitesProfessionnelles',
            'ObtenirActivitesProfessionnellesResponse' => '\\april\\StructType\\ObtenirActivitesProfessionnellesResponse',
            'ReponseObtenirReferentielActivitesProfessionnelles' => '\\april\\StructType\\ReponseObtenirReferentielActivitesProfessionnelles',
            'ArrayOfActiviteProfessionnelleReference' => '\\april\\ArrayType\\ArrayOfActiviteProfessionnelleReference',
            'ActiviteProfessionnelleReference' => '\\april\\StructType\\ActiviteProfessionnelleReference',
            'ObtenirSituationsFamiliales' => '\\april\\StructType\\ObtenirSituationsFamiliales',
            'ObtenirSituationsFamilialesResponse' => '\\april\\StructType\\ObtenirSituationsFamilialesResponse',
            'ReponseObtenirReferentielSituationsFamiliales' => '\\april\\StructType\\ReponseObtenirReferentielSituationsFamiliales',
            'ArrayOfSituationFamilialeReference' => '\\april\\ArrayType\\ArrayOfSituationFamilialeReference',
            'SituationFamilialeReference' => '\\april\\StructType\\SituationFamilialeReference',
            'ObtenirNationalite' => '\\april\\StructType\\ObtenirNationalite',
            'ObtenirNationaliteResponse' => '\\april\\StructType\\ObtenirNationaliteResponse',
            'ReponseObtenirReferentielNationalite' => '\\april\\StructType\\ReponseObtenirReferentielNationalite',
            'ArrayOfNationaliteReference' => '\\april\\ArrayType\\ArrayOfNationaliteReference',
            'NationaliteReference' => '\\april\\StructType\\NationaliteReference',
            'DemandeObtenirReferentiel' => '\\april\\StructType\\DemandeObtenirReferentiel',
            'ReponseObtenirReferentielPays' => '\\april\\StructType\\ReponseObtenirReferentielPays',
            'ReponseObtenirReferentielDepartement' => '\\april\\StructType\\ReponseObtenirReferentielDepartement',
            'ReponseObtenirReferentielVille' => '\\april\\StructType\\ReponseObtenirReferentielVille',
        );
    }
}
