<?php

namespace april\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Obtenir ServiceType
 * @subpackage Services
 */
class Obtenir extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named ObtenirRecommandation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirRecommandation $parameters
     * @return \april\StructType\ObtenirRecommandationResponse|bool
     */
    public function ObtenirRecommandation(\april\StructType\ObtenirRecommandation $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirRecommandation($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirTarif
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirTarif $parameters
     * @return \april\StructType\ObtenirTarifResponse|bool
     */
    public function ObtenirTarif(\april\StructType\ObtenirTarif $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirTarif($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirDocumentSimulation
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirDocumentSimulation $parameters
     * @return \april\StructType\ObtenirDocumentSimulationResponse|bool
     */
    public function ObtenirDocumentSimulation(\april\StructType\ObtenirDocumentSimulation $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirDocumentSimulation($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirDocumentPreAdhesion
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirDocumentPreAdhesion $parameters
     * @return \april\StructType\ObtenirDocumentPreAdhesionResponse|bool
     */
    public function ObtenirDocumentPreAdhesion(\april\StructType\ObtenirDocumentPreAdhesion $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirDocumentPreAdhesion($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirProfessions
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirProfessions $parameters
     * @return \april\StructType\ObtenirProfessionsResponse|bool
     */
    public function ObtenirProfessions(\april\StructType\ObtenirProfessions $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirProfessions($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirRegimesObligatoires
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirRegimesObligatoires $parameters
     * @return \april\StructType\ObtenirRegimesObligatoiresResponse|bool
     */
    public function ObtenirRegimesObligatoires(\april\StructType\ObtenirRegimesObligatoires $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirRegimesObligatoires($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirGaranties
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirGaranties $parameters
     * @return \april\StructType\ObtenirGarantiesResponse|bool
     */
    public function ObtenirGaranties(\april\StructType\ObtenirGaranties $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirGaranties($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirCommissionnements
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirCommissionnements $parameters
     * @return \april\StructType\ObtenirCommissionnementsResponse|bool
     */
    public function ObtenirCommissionnements(\april\StructType\ObtenirCommissionnements $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirCommissionnements($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirPays
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirPays $parameters
     * @return \april\StructType\ObtenirPaysResponse|bool
     */
    public function ObtenirPays(\april\StructType\ObtenirPays $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirPays($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirDepartements
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirDepartements $parameters
     * @return \april\StructType\ObtenirDepartementsResponse|bool
     */
    public function ObtenirDepartements(\april\StructType\ObtenirDepartements $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirDepartements($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirVille
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirVille $parameters
     * @return \april\StructType\ObtenirVilleResponse|bool
     */
    public function ObtenirVille(\april\StructType\ObtenirVille $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirVille($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirURLProjet
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirURLProjet $parameters
     * @return \april\StructType\ObtenirURLProjetResponse|bool
     */
    public function ObtenirURLProjet(\april\StructType\ObtenirURLProjet $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirURLProjet($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirActivitesProfessionnelles
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirActivitesProfessionnelles $parameters
     * @return \april\StructType\ObtenirActivitesProfessionnellesResponse|bool
     */
    public function ObtenirActivitesProfessionnelles(\april\StructType\ObtenirActivitesProfessionnelles $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirActivitesProfessionnelles($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirSituationsFamiliales
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirSituationsFamiliales $parameters
     * @return \april\StructType\ObtenirSituationsFamilialesResponse|bool
     */
    public function ObtenirSituationsFamiliales(\april\StructType\ObtenirSituationsFamiliales $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirSituationsFamiliales($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named ObtenirNationalite
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \april\StructType\ObtenirNationalite $parameters
     * @return \april\StructType\ObtenirNationaliteResponse|bool
     */
    public function ObtenirNationalite(\april\StructType\ObtenirNationalite $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->ObtenirNationalite($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \april\StructType\ObtenirActivitesProfessionnellesResponse|\april\StructType\ObtenirCommissionnementsResponse|\april\StructType\ObtenirDepartementsResponse|\april\StructType\ObtenirDocumentPreAdhesionResponse|\april\StructType\ObtenirDocumentSimulationResponse|\april\StructType\ObtenirGarantiesResponse|\april\StructType\ObtenirNationaliteResponse|\april\StructType\ObtenirPaysResponse|\april\StructType\ObtenirProfessionsResponse|\april\StructType\ObtenirRecommandationResponse|\april\StructType\ObtenirRegimesObligatoiresResponse|\april\StructType\ObtenirSituationsFamilialesResponse|\april\StructType\ObtenirTarifResponse|\april\StructType\ObtenirURLProjetResponse|\april\StructType\ObtenirVilleResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
