<?php

namespace april\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Adresse StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Adresse
 * @subpackage Structs
 */
class Adresse extends AbstractStructBase
{
    /**
     * The AdresseLigne1
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AdresseLigne1;
    /**
     * The AdresseLigne2
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AdresseLigne2;
    /**
     * The CodePostal
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodePostal;
    /**
     * The Ville
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Ville;
    /**
     * Constructor method for Adresse
     * @uses Adresse::setAdresseLigne1()
     * @uses Adresse::setAdresseLigne2()
     * @uses Adresse::setCodePostal()
     * @uses Adresse::setVille()
     * @param string $adresseLigne1
     * @param string $adresseLigne2
     * @param string $codePostal
     * @param string $ville
     */
    public function __construct($adresseLigne1 = null, $adresseLigne2 = null, $codePostal = null, $ville = null)
    {
        $this
            ->setAdresseLigne1($adresseLigne1)
            ->setAdresseLigne2($adresseLigne2)
            ->setCodePostal($codePostal)
            ->setVille($ville);
    }
    /**
     * Get AdresseLigne1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAdresseLigne1()
    {
        return isset($this->AdresseLigne1) ? $this->AdresseLigne1 : null;
    }
    /**
     * Set AdresseLigne1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $adresseLigne1
     * @return \april\StructType\Adresse
     */
    public function setAdresseLigne1($adresseLigne1 = null)
    {
        // validation for constraint: string
        if (!is_null($adresseLigne1) && !is_string($adresseLigne1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($adresseLigne1)), __LINE__);
        }
        if (is_null($adresseLigne1) || (is_array($adresseLigne1) && empty($adresseLigne1))) {
            unset($this->AdresseLigne1);
        } else {
            $this->AdresseLigne1 = $adresseLigne1;
        }
        return $this;
    }
    /**
     * Get AdresseLigne2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAdresseLigne2()
    {
        return isset($this->AdresseLigne2) ? $this->AdresseLigne2 : null;
    }
    /**
     * Set AdresseLigne2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $adresseLigne2
     * @return \april\StructType\Adresse
     */
    public function setAdresseLigne2($adresseLigne2 = null)
    {
        // validation for constraint: string
        if (!is_null($adresseLigne2) && !is_string($adresseLigne2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($adresseLigne2)), __LINE__);
        }
        if (is_null($adresseLigne2) || (is_array($adresseLigne2) && empty($adresseLigne2))) {
            unset($this->AdresseLigne2);
        } else {
            $this->AdresseLigne2 = $adresseLigne2;
        }
        return $this;
    }
    /**
     * Get CodePostal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodePostal()
    {
        return isset($this->CodePostal) ? $this->CodePostal : null;
    }
    /**
     * Set CodePostal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codePostal
     * @return \april\StructType\Adresse
     */
    public function setCodePostal($codePostal = null)
    {
        // validation for constraint: string
        if (!is_null($codePostal) && !is_string($codePostal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codePostal)), __LINE__);
        }
        if (is_null($codePostal) || (is_array($codePostal) && empty($codePostal))) {
            unset($this->CodePostal);
        } else {
            $this->CodePostal = $codePostal;
        }
        return $this;
    }
    /**
     * Get Ville value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getVille()
    {
        return isset($this->Ville) ? $this->Ville : null;
    }
    /**
     * Set Ville value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ville
     * @return \april\StructType\Adresse
     */
    public function setVille($ville = null)
    {
        // validation for constraint: string
        if (!is_null($ville) && !is_string($ville)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($ville)), __LINE__);
        }
        if (is_null($ville) || (is_array($ville) && empty($ville))) {
            unset($this->Ville);
        } else {
            $this->Ville = $ville;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \april\StructType\Adresse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
