<?php

namespace april\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Couverture StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Couverture
 * @subpackage Structs
 */
class Couverture extends AbstractStructBase
{
    /**
     * The CodeGarantie
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodeGarantie;
    /**
     * The CodeNiveau
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodeNiveau;
    /**
     * The CodeFranchise
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodeFranchise;
    /**
     * Constructor method for Couverture
     * @uses Couverture::setCodeGarantie()
     * @uses Couverture::setCodeNiveau()
     * @uses Couverture::setCodeFranchise()
     * @param string $codeGarantie
     * @param string $codeNiveau
     * @param string $codeFranchise
     */
    public function __construct($codeGarantie = null, $codeNiveau = null, $codeFranchise = null)
    {
        $this
            ->setCodeGarantie($codeGarantie)
            ->setCodeNiveau($codeNiveau)
            ->setCodeFranchise($codeFranchise);
    }
    /**
     * Get CodeGarantie value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodeGarantie()
    {
        return isset($this->CodeGarantie) ? $this->CodeGarantie : null;
    }
    /**
     * Set CodeGarantie value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codeGarantie
     * @return \april\StructType\Couverture
     */
    public function setCodeGarantie($codeGarantie = null)
    {
        // validation for constraint: string
        if (!is_null($codeGarantie) && !is_string($codeGarantie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codeGarantie)), __LINE__);
        }
        if (is_null($codeGarantie) || (is_array($codeGarantie) && empty($codeGarantie))) {
            unset($this->CodeGarantie);
        } else {
            $this->CodeGarantie = $codeGarantie;
        }
        return $this;
    }
    /**
     * Get CodeNiveau value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodeNiveau()
    {
        return isset($this->CodeNiveau) ? $this->CodeNiveau : null;
    }
    /**
     * Set CodeNiveau value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codeNiveau
     * @return \april\StructType\Couverture
     */
    public function setCodeNiveau($codeNiveau = null)
    {
        // validation for constraint: string
        if (!is_null($codeNiveau) && !is_string($codeNiveau)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codeNiveau)), __LINE__);
        }
        if (is_null($codeNiveau) || (is_array($codeNiveau) && empty($codeNiveau))) {
            unset($this->CodeNiveau);
        } else {
            $this->CodeNiveau = $codeNiveau;
        }
        return $this;
    }
    /**
     * Get CodeFranchise value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodeFranchise()
    {
        return isset($this->CodeFranchise) ? $this->CodeFranchise : null;
    }
    /**
     * Set CodeFranchise value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codeFranchise
     * @return \april\StructType\Couverture
     */
    public function setCodeFranchise($codeFranchise = null)
    {
        // validation for constraint: string
        if (!is_null($codeFranchise) && !is_string($codeFranchise)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codeFranchise)), __LINE__);
        }
        if (is_null($codeFranchise) || (is_array($codeFranchise) && empty($codeFranchise))) {
            unset($this->CodeFranchise);
        } else {
            $this->CodeFranchise = $codeFranchise;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \april\StructType\Couverture
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
