<?php

namespace april\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Document StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Document
 * @subpackage Structs
 */
class Document extends AbstractStructBase
{
    /**
     * The Identifiant
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Identifiant;
    /**
     * The TypeDocument
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TypeDocument;
    /**
     * The Nom
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Nom;
    /**
     * The Libelle
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Libelle;
    /**
     * The Contenu
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Contenu;
    /**
     * Constructor method for Document
     * @uses Document::setIdentifiant()
     * @uses Document::setTypeDocument()
     * @uses Document::setNom()
     * @uses Document::setLibelle()
     * @uses Document::setContenu()
     * @param string $identifiant
     * @param string $typeDocument
     * @param string $nom
     * @param string $libelle
     * @param string $contenu
     */
    public function __construct($identifiant = null, $typeDocument = null, $nom = null, $libelle = null, $contenu = null)
    {
        $this
            ->setIdentifiant($identifiant)
            ->setTypeDocument($typeDocument)
            ->setNom($nom)
            ->setLibelle($libelle)
            ->setContenu($contenu);
    }
    /**
     * Get Identifiant value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentifiant()
    {
        return isset($this->Identifiant) ? $this->Identifiant : null;
    }
    /**
     * Set Identifiant value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identifiant
     * @return \april\StructType\Document
     */
    public function setIdentifiant($identifiant = null)
    {
        // validation for constraint: string
        if (!is_null($identifiant) && !is_string($identifiant)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identifiant)), __LINE__);
        }
        if (is_null($identifiant) || (is_array($identifiant) && empty($identifiant))) {
            unset($this->Identifiant);
        } else {
            $this->Identifiant = $identifiant;
        }
        return $this;
    }
    /**
     * Get TypeDocument value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTypeDocument()
    {
        return isset($this->TypeDocument) ? $this->TypeDocument : null;
    }
    /**
     * Set TypeDocument value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $typeDocument
     * @return \april\StructType\Document
     */
    public function setTypeDocument($typeDocument = null)
    {
        // validation for constraint: string
        if (!is_null($typeDocument) && !is_string($typeDocument)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($typeDocument)), __LINE__);
        }
        if (is_null($typeDocument) || (is_array($typeDocument) && empty($typeDocument))) {
            unset($this->TypeDocument);
        } else {
            $this->TypeDocument = $typeDocument;
        }
        return $this;
    }
    /**
     * Get Nom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNom()
    {
        return isset($this->Nom) ? $this->Nom : null;
    }
    /**
     * Set Nom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nom
     * @return \april\StructType\Document
     */
    public function setNom($nom = null)
    {
        // validation for constraint: string
        if (!is_null($nom) && !is_string($nom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nom)), __LINE__);
        }
        if (is_null($nom) || (is_array($nom) && empty($nom))) {
            unset($this->Nom);
        } else {
            $this->Nom = $nom;
        }
        return $this;
    }
    /**
     * Get Libelle value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLibelle()
    {
        return isset($this->Libelle) ? $this->Libelle : null;
    }
    /**
     * Set Libelle value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $libelle
     * @return \april\StructType\Document
     */
    public function setLibelle($libelle = null)
    {
        // validation for constraint: string
        if (!is_null($libelle) && !is_string($libelle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($libelle)), __LINE__);
        }
        if (is_null($libelle) || (is_array($libelle) && empty($libelle))) {
            unset($this->Libelle);
        } else {
            $this->Libelle = $libelle;
        }
        return $this;
    }
    /**
     * Get Contenu value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getContenu()
    {
        return isset($this->Contenu) ? $this->Contenu : null;
    }
    /**
     * Set Contenu value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $contenu
     * @return \april\StructType\Document
     */
    public function setContenu($contenu = null)
    {
        // validation for constraint: string
        if (!is_null($contenu) && !is_string($contenu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contenu)), __LINE__);
        }
        if (is_null($contenu) || (is_array($contenu) && empty($contenu))) {
            unset($this->Contenu);
        } else {
            $this->Contenu = $contenu;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \april\StructType\Document
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
