<?php

namespace april\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MessageMetier StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:MessageMetier
 * @subpackage Structs
 */
class MessageMetier extends AbstractStructBase
{
    /**
     * The Reference
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Reference;
    /**
     * The IdentifiantReference
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IdentifiantReference;
    /**
     * The ProprieteReference
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ProprieteReference;
    /**
     * The Libelle
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Libelle;
    /**
     * Constructor method for MessageMetier
     * @uses MessageMetier::setReference()
     * @uses MessageMetier::setIdentifiantReference()
     * @uses MessageMetier::setProprieteReference()
     * @uses MessageMetier::setLibelle()
     * @param string $reference
     * @param string $identifiantReference
     * @param string $proprieteReference
     * @param string $libelle
     */
    public function __construct($reference = null, $identifiantReference = null, $proprieteReference = null, $libelle = null)
    {
        $this
            ->setReference($reference)
            ->setIdentifiantReference($identifiantReference)
            ->setProprieteReference($proprieteReference)
            ->setLibelle($libelle);
    }
    /**
     * Get Reference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getReference()
    {
        return isset($this->Reference) ? $this->Reference : null;
    }
    /**
     * Set Reference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $reference
     * @return \april\StructType\MessageMetier
     */
    public function setReference($reference = null)
    {
        // validation for constraint: string
        if (!is_null($reference) && !is_string($reference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($reference)), __LINE__);
        }
        if (is_null($reference) || (is_array($reference) && empty($reference))) {
            unset($this->Reference);
        } else {
            $this->Reference = $reference;
        }
        return $this;
    }
    /**
     * Get IdentifiantReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentifiantReference()
    {
        return isset($this->IdentifiantReference) ? $this->IdentifiantReference : null;
    }
    /**
     * Set IdentifiantReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identifiantReference
     * @return \april\StructType\MessageMetier
     */
    public function setIdentifiantReference($identifiantReference = null)
    {
        // validation for constraint: string
        if (!is_null($identifiantReference) && !is_string($identifiantReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identifiantReference)), __LINE__);
        }
        if (is_null($identifiantReference) || (is_array($identifiantReference) && empty($identifiantReference))) {
            unset($this->IdentifiantReference);
        } else {
            $this->IdentifiantReference = $identifiantReference;
        }
        return $this;
    }
    /**
     * Get ProprieteReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getProprieteReference()
    {
        return isset($this->ProprieteReference) ? $this->ProprieteReference : null;
    }
    /**
     * Set ProprieteReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $proprieteReference
     * @return \april\StructType\MessageMetier
     */
    public function setProprieteReference($proprieteReference = null)
    {
        // validation for constraint: string
        if (!is_null($proprieteReference) && !is_string($proprieteReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($proprieteReference)), __LINE__);
        }
        if (is_null($proprieteReference) || (is_array($proprieteReference) && empty($proprieteReference))) {
            unset($this->ProprieteReference);
        } else {
            $this->ProprieteReference = $proprieteReference;
        }
        return $this;
    }
    /**
     * Get Libelle value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLibelle()
    {
        return isset($this->Libelle) ? $this->Libelle : null;
    }
    /**
     * Set Libelle value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $libelle
     * @return \april\StructType\MessageMetier
     */
    public function setLibelle($libelle = null)
    {
        // validation for constraint: string
        if (!is_null($libelle) && !is_string($libelle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($libelle)), __LINE__);
        }
        if (is_null($libelle) || (is_array($libelle) && empty($libelle))) {
            unset($this->Libelle);
        } else {
            $this->Libelle = $libelle;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \april\StructType\MessageMetier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
