<?php

namespace april\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Personne StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Personne
 * @subpackage Structs
 */
class Personne extends AbstractStructBase
{
    /**
     * The Civilite
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Civilite;
    /**
     * The Nom
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Nom;
    /**
     * The Prenom
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Prenom;
    /**
     * The DateDeNaissance
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DateDeNaissance;
    /**
     * Constructor method for Personne
     * @uses Personne::setCivilite()
     * @uses Personne::setNom()
     * @uses Personne::setPrenom()
     * @uses Personne::setDateDeNaissance()
     * @param string $civilite
     * @param string $nom
     * @param string $prenom
     * @param string $dateDeNaissance
     */
    public function __construct($civilite = null, $nom = null, $prenom = null, $dateDeNaissance = null)
    {
        $this
            ->setCivilite($civilite)
            ->setNom($nom)
            ->setPrenom($prenom)
            ->setDateDeNaissance($dateDeNaissance);
    }
    /**
     * Get Civilite value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCivilite()
    {
        return isset($this->Civilite) ? $this->Civilite : null;
    }
    /**
     * Set Civilite value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $civilite
     * @return \april\StructType\Personne
     */
    public function setCivilite($civilite = null)
    {
        // validation for constraint: string
        if (!is_null($civilite) && !is_string($civilite)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($civilite)), __LINE__);
        }
        if (is_null($civilite) || (is_array($civilite) && empty($civilite))) {
            unset($this->Civilite);
        } else {
            $this->Civilite = $civilite;
        }
        return $this;
    }
    /**
     * Get Nom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getNom()
    {
        return isset($this->Nom) ? $this->Nom : null;
    }
    /**
     * Set Nom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $nom
     * @return \april\StructType\Personne
     */
    public function setNom($nom = null)
    {
        // validation for constraint: string
        if (!is_null($nom) && !is_string($nom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nom)), __LINE__);
        }
        if (is_null($nom) || (is_array($nom) && empty($nom))) {
            unset($this->Nom);
        } else {
            $this->Nom = $nom;
        }
        return $this;
    }
    /**
     * Get Prenom value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPrenom()
    {
        return isset($this->Prenom) ? $this->Prenom : null;
    }
    /**
     * Set Prenom value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $prenom
     * @return \april\StructType\Personne
     */
    public function setPrenom($prenom = null)
    {
        // validation for constraint: string
        if (!is_null($prenom) && !is_string($prenom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prenom)), __LINE__);
        }
        if (is_null($prenom) || (is_array($prenom) && empty($prenom))) {
            unset($this->Prenom);
        } else {
            $this->Prenom = $prenom;
        }
        return $this;
    }
    /**
     * Get DateDeNaissance value
     * @return string|null
     */
    public function getDateDeNaissance()
    {
        return $this->DateDeNaissance;
    }
    /**
     * Set DateDeNaissance value
     * @param string $dateDeNaissance
     * @return \april\StructType\Personne
     */
    public function setDateDeNaissance($dateDeNaissance = null)
    {
        // validation for constraint: string
        if (!is_null($dateDeNaissance) && !is_string($dateDeNaissance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateDeNaissance)), __LINE__);
        }
        $this->DateDeNaissance = $dateDeNaissance;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \april\StructType\Personne
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
