<?php

namespace april\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Promotion StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Promotion
 * @subpackage Structs
 */
class Promotion extends AbstractStructBase
{
    /**
     * The CodePromotion
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodePromotion;
    /**
     * The ValeurPromotion
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ValeurPromotion;
    /**
     * Constructor method for Promotion
     * @uses Promotion::setCodePromotion()
     * @uses Promotion::setValeurPromotion()
     * @param string $codePromotion
     * @param string $valeurPromotion
     */
    public function __construct($codePromotion = null, $valeurPromotion = null)
    {
        $this
            ->setCodePromotion($codePromotion)
            ->setValeurPromotion($valeurPromotion);
    }
    /**
     * Get CodePromotion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodePromotion()
    {
        return isset($this->CodePromotion) ? $this->CodePromotion : null;
    }
    /**
     * Set CodePromotion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codePromotion
     * @return \april\StructType\Promotion
     */
    public function setCodePromotion($codePromotion = null)
    {
        // validation for constraint: string
        if (!is_null($codePromotion) && !is_string($codePromotion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codePromotion)), __LINE__);
        }
        if (is_null($codePromotion) || (is_array($codePromotion) && empty($codePromotion))) {
            unset($this->CodePromotion);
        } else {
            $this->CodePromotion = $codePromotion;
        }
        return $this;
    }
    /**
     * Get ValeurPromotion value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValeurPromotion()
    {
        return isset($this->ValeurPromotion) ? $this->ValeurPromotion : null;
    }
    /**
     * Set ValeurPromotion value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $valeurPromotion
     * @return \april\StructType\Promotion
     */
    public function setValeurPromotion($valeurPromotion = null)
    {
        // validation for constraint: string
        if (!is_null($valeurPromotion) && !is_string($valeurPromotion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($valeurPromotion)), __LINE__);
        }
        if (is_null($valeurPromotion) || (is_array($valeurPromotion) && empty($valeurPromotion))) {
            unset($this->ValeurPromotion);
        } else {
            $this->ValeurPromotion = $valeurPromotion;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \april\StructType\Promotion
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
