<?php

namespace april\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Tarif StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:Tarif
 * @subpackage Structs
 */
class Tarif extends AbstractStructBase
{
    /**
     * The CotisationAnnuelle
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $CotisationAnnuelle;
    /**
     * The CotisationMensuelle
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $CotisationMensuelle;
    /**
     * The DateFinValiditeTarif
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $DateFinValiditeTarif;
    /**
     * Constructor method for Tarif
     * @uses Tarif::setCotisationAnnuelle()
     * @uses Tarif::setCotisationMensuelle()
     * @uses Tarif::setDateFinValiditeTarif()
     * @param float $cotisationAnnuelle
     * @param float $cotisationMensuelle
     * @param string $dateFinValiditeTarif
     */
    public function __construct($cotisationAnnuelle = null, $cotisationMensuelle = null, $dateFinValiditeTarif = null)
    {
        $this
            ->setCotisationAnnuelle($cotisationAnnuelle)
            ->setCotisationMensuelle($cotisationMensuelle)
            ->setDateFinValiditeTarif($dateFinValiditeTarif);
    }
    /**
     * Get CotisationAnnuelle value
     * @return float|null
     */
    public function getCotisationAnnuelle()
    {
        return $this->CotisationAnnuelle;
    }
    /**
     * Set CotisationAnnuelle value
     * @param float $cotisationAnnuelle
     * @return \april\StructType\Tarif
     */
    public function setCotisationAnnuelle($cotisationAnnuelle = null)
    {
        $this->CotisationAnnuelle = $cotisationAnnuelle;
        return $this;
    }
    /**
     * Get CotisationMensuelle value
     * @return float|null
     */
    public function getCotisationMensuelle()
    {
        return $this->CotisationMensuelle;
    }
    /**
     * Set CotisationMensuelle value
     * @param float $cotisationMensuelle
     * @return \april\StructType\Tarif
     */
    public function setCotisationMensuelle($cotisationMensuelle = null)
    {
        $this->CotisationMensuelle = $cotisationMensuelle;
        return $this;
    }
    /**
     * Get DateFinValiditeTarif value
     * @return string|null
     */
    public function getDateFinValiditeTarif()
    {
        return $this->DateFinValiditeTarif;
    }
    /**
     * Set DateFinValiditeTarif value
     * @param string $dateFinValiditeTarif
     * @return \april\StructType\Tarif
     */
    public function setDateFinValiditeTarif($dateFinValiditeTarif = null)
    {
        // validation for constraint: string
        if (!is_null($dateFinValiditeTarif) && !is_string($dateFinValiditeTarif)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateFinValiditeTarif)), __LINE__);
        }
        $this->DateFinValiditeTarif = $dateFinValiditeTarif;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \april\StructType\Tarif
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
